package cn.ibizlab.businesscentral.core.odoo_account.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_invoice_report;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_invoice_reportSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Account_invoice_report] 服务对象接口
 */
public interface IAccount_invoice_reportService extends IService<Account_invoice_report>{

    boolean create(Account_invoice_report et) ;
    void createBatch(List<Account_invoice_report> list) ;
    boolean update(Account_invoice_report et) ;
    void updateBatch(List<Account_invoice_report> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Account_invoice_report get(Long key) ;
    Account_invoice_report getDraft(Account_invoice_report et) ;
    boolean checkKey(Account_invoice_report et) ;
    boolean save(Account_invoice_report et) ;
    void saveBatch(List<Account_invoice_report> list) ;
    Page<Account_invoice_report> searchDefault(Account_invoice_reportSearchContext context) ;
    List<Account_invoice_report> selectByAccountId(Long id);
    void resetByAccountId(Long id);
    void resetByAccountId(Collection<Long> ids);
    void removeByAccountId(Long id);
    List<Account_invoice_report> selectByAccountLineId(Long id);
    void resetByAccountLineId(Long id);
    void resetByAccountLineId(Collection<Long> ids);
    void removeByAccountLineId(Long id);
    List<Account_invoice_report> selectByAccountAnalyticId(Long id);
    void resetByAccountAnalyticId(Long id);
    void resetByAccountAnalyticId(Collection<Long> ids);
    void removeByAccountAnalyticId(Long id);
    List<Account_invoice_report> selectByFiscalPositionId(Long id);
    void resetByFiscalPositionId(Long id);
    void resetByFiscalPositionId(Collection<Long> ids);
    void removeByFiscalPositionId(Long id);
    List<Account_invoice_report> selectByInvoiceId(Long id);
    void resetByInvoiceId(Long id);
    void resetByInvoiceId(Collection<Long> ids);
    void removeByInvoiceId(Long id);
    List<Account_invoice_report> selectByJournalId(Long id);
    void resetByJournalId(Long id);
    void resetByJournalId(Collection<Long> ids);
    void removeByJournalId(Long id);
    List<Account_invoice_report> selectByPaymentTermId(Long id);
    void resetByPaymentTermId(Long id);
    void resetByPaymentTermId(Collection<Long> ids);
    void removeByPaymentTermId(Long id);
    List<Account_invoice_report> selectByTeamId(Long id);
    void resetByTeamId(Long id);
    void resetByTeamId(Collection<Long> ids);
    void removeByTeamId(Long id);
    List<Account_invoice_report> selectByCategId(Long id);
    void resetByCategId(Long id);
    void resetByCategId(Collection<Long> ids);
    void removeByCategId(Long id);
    List<Account_invoice_report> selectByProductId(Long id);
    void resetByProductId(Long id);
    void resetByProductId(Collection<Long> ids);
    void removeByProductId(Long id);
    List<Account_invoice_report> selectByCompanyId(Long id);
    void resetByCompanyId(Long id);
    void resetByCompanyId(Collection<Long> ids);
    void removeByCompanyId(Long id);
    List<Account_invoice_report> selectByCountryId(Long id);
    void resetByCountryId(Long id);
    void resetByCountryId(Collection<Long> ids);
    void removeByCountryId(Long id);
    List<Account_invoice_report> selectByCurrencyId(Long id);
    void resetByCurrencyId(Long id);
    void resetByCurrencyId(Collection<Long> ids);
    void removeByCurrencyId(Long id);
    List<Account_invoice_report> selectByPartnerBankId(Long id);
    void resetByPartnerBankId(Long id);
    void resetByPartnerBankId(Collection<Long> ids);
    void removeByPartnerBankId(Long id);
    List<Account_invoice_report> selectByCommercialPartnerId(Long id);
    void resetByCommercialPartnerId(Long id);
    void resetByCommercialPartnerId(Collection<Long> ids);
    void removeByCommercialPartnerId(Long id);
    List<Account_invoice_report> selectByPartnerId(Long id);
    void resetByPartnerId(Long id);
    void resetByPartnerId(Collection<Long> ids);
    void removeByPartnerId(Long id);
    List<Account_invoice_report> selectByUserId(Long id);
    void resetByUserId(Long id);
    void resetByUserId(Collection<Long> ids);
    void removeByUserId(Long id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


